package CoPS.CheckUpExample;

//
//  CheckUpDecomposer.java
//  CoPS
//
//  Created by Kari on 20.11.05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//


//CoPS classes
import CoPS.agents.CoPSDecomposer;
import CoPS.Exceptions.NotAbleToDecomposeTaskException;

//Jade classes
import jade.domain.FIPAAgentManagement.ServiceDescription;

//TMST classes
import TMST.representation.TMST;

/**
 * A class extending CoPSDecomposer, which implements a decomposer in 
 * our Checkup example application.
 * @author Kari Roessland
 */
public class CheckUpDecomposer extends CoPSDecomposer{

	/**
	 * Dummy method, always returning the stored library
	 * @return The stored TMST.
	 */
	protected TMST decomposeProblem(String task) throws NotAbleToDecomposeTaskException{
		return library;
	}
	
	/**
	 * Dummy method always returning true.
	 * @return True.
	 */
	protected boolean correctFormat(String task){
		return true;	
	}
	
	/*
     * Method setting the library to a TMST that is created from the file "CheckUp.km".
	 * @return The TMST that was created.
	 */
	protected TMST setTaskStructureLibrary(){
		TMST tmst = null;
		
		try{
			tmst = new TMST("CheckUp.km");
		}catch(Exception e){
			e.getMessage();
			e.printStackTrace();
		}
		return tmst;
	}
	
	/**
	 * Method overridden from the class CoPSAgent.
	 * @return The agents ServiceDescription object to be registered with the DF.
	 */
	public ServiceDescription setServiceDescription(){
		
        ServiceDescription sd = new ServiceDescription();
        sd.setType("DECOMPOSER");
        sd.setName(this.getName());
        sd.setOwnership("KariR");
		
		

		return sd;
	}

}
