package CoPS.agents;
//
//  DFRegisteringBehaviour.java
//  CoPS
//
//  Created by Kari on 31.01.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

//JAVA classes
import java.util.ArrayList;

//JADE classes
import jade.core.behaviours.OneShotBehaviour;
import jade.core.Agent;
import jade.lang.acl.ACLMessage;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.DFService;

/**
 * This class contains the behaviour for registering a service with the DF, extends OneShotBehaviour
 *
 */            
public class DFRegisteringBehaviour extends OneShotBehaviour{
	ServiceDescription sd = null;
	
	/**
	 * The constructor.
	 * @param ag The owner of this behaviour.
	 * @param sd The agent ServiceDescription
	 */
	public DFRegisteringBehaviour(Agent ag, ServiceDescription sd){
        super(ag);
		this.sd = sd;
    }
    
	/**
	 * In the action method the service description is registered with the JADE DF.
	 */
    public void action(){
        DFAgentDescription dfd = new DFAgentDescription();
        dfd.setName(myAgent.getAID());
        dfd.addServices(this.sd);
        try{
            DFAgentDescription[] dfds = DFService.search(myAgent, dfd);
            if(dfds.length>0){ DFService.deregister(myAgent, dfd); }
            DFService.register(myAgent, dfd);
            System.out.println("    "+myAgent.getLocalName() +" is ready!");
        }catch(Exception e){
            System.out.println("    "+myAgent.getLocalName() +" not Able to register with DF. Agent shutting down!");
            e.printStackTrace();
            myAgent.doDelete();
        }
    }
}