package CoPS.CheckUpExample;
//
//  DefaultAgent.java
//  CoPS
//
//  Created by Kari on 14.04.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
import jade.core.Agent;
import jade.lang.acl.ACLMessage;
import jade.domain.FIPANames; 
import jade.core.AID;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.DFService;


/**
 * This class implements a default agent, used to run the default agent behaviour.
 * @author Kari Roessland.
 */
public class DefaultAgent extends Agent{

	/**
	 * The method sets up the agent for start running its behaviours.
	 */
	public void setup(){
		//has to wait so that the task responsible is registered
		this.doWait(3000);
		
		ACLMessage request = new ACLMessage(ACLMessage.REQUEST);
		request.setProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST);		
		
		this.addBehaviour(new DefaultAgentBehaviour(this, request));
	}


	/**
	 * The method returns a list of Task Responsibles.
	 * @return A list of DFAgentDescription describing the Task Responsibles in the system.
	 */
	public DFAgentDescription[] getTaskResponsible(){
		DFAgentDescription possibleAgents[] = lookup("TASK_RESPONSIBLE");
		
		if(possibleAgents==null || possibleAgents.length == 0){
			return null;
		}
		
		return possibleAgents;
	}	


	/**
	 * The method looks up an agentType in the JADE DF - service.
	 * @param agentType A string defining the agent-type (service) to be looked up.
	 * @return A list of DFAgentDescription objects describing the agents that have been looked up.
	 */
    private DFAgentDescription[] lookup(String agentType){
		//return value
		DFAgentDescription[] result = null; 

        //Has to specify the services we are looking for
        DFAgentDescription dfd = new DFAgentDescription();
        ServiceDescription sd = new ServiceDescription();
        sd.setType(agentType);
        dfd.addServices(sd);
		
        //The specified service has to be looked up in the DF
        try{
			result = DFService.search((Agent)this, dfd);
        }catch(Exception e){
            e.printStackTrace();
        }
		return result;
    }
	


}
