package CoPS.CheckUpExample;
//
//  DefaultAgentBehaviour.java
//  CoPS
//
//  Created by Kari on 14.04.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

import jade.core.Agent;
import jade.proto.AchieveREInitiator;
import jade.lang.acl.ACLMessage;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import java.util.Vector;

/**
 * This class implements a default agent behaviour sending task solving request to a TaskResponsible.
 * Used for running the example application.
 * @author Kari Roessland
 */
public class DefaultAgentBehaviour extends AchieveREInitiator{

	/**
	 * The constructor.
	 * @param agent The owner of this behaviour.
	 * @param request The default request message.
	 */
	public DefaultAgentBehaviour(Agent agent, ACLMessage request){
		super(agent, request);
	}

	/**
	 * This method prepares and sends a request message. If there are several Task Responsible agents
	 * in the system 2 requests are sent, to demonstrate parallel problem solving in the team space.
	 * @param The default request message
	 * @return A vector containing the requests.
	 */
	protected Vector prepareRequests(ACLMessage request){	
		Vector requests = new Vector();
		
		DFAgentDescription taskResponsibles[] = ((DefaultAgent)myAgent).getTaskResponsible();
		boolean first = true;
		ACLMessage req = null;
		
		//this is harcoded, just to show an example of the parallel solution
		for(int i = 0; i<taskResponsibles.length; i++){
			req = (ACLMessage)request.clone();
			if(first){
				req.setContent("(Task :name doCheckup :input (Patient :name paul))");
				first = false;
			}else{
				req.setContent("(Task :name doCheckup :input (Patient :name maria))");
			}
			req.addReceiver(taskResponsibles[i].getName());
			requests.add(req);
		}
		
		return requests;
	}
}
