//
//  FileWriter.java
//  TestAgents
//
//  Created by Kari on 15.05.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

package CoPS;

import java.io.*;


/**
 * This class handles the writing to a file of logged information
 * during the problem solving process of a TR agent and the other
 * agents the TR brings into this process.
 * @author Kari Roessland
 */

public class FileWriter implements Serializable{
	String file = "";
	
	/**
	 * The constructur.
	 * @param file the name of the file that should be written to.
	 */
	public FileWriter(String file){
		this.file = file;
	}
	
	/**
	 * This method handles the writing
	 * @param text the text that should be written to the file.
	 */
	public void write(String text){
	
		FileOutputStream fout;          
		
		try{
				// Open an output stream
			
			fout = new FileOutputStream(file, true);

			// Print a line of text
			new PrintStream(fout).println(text);

			// Close our output stream
			fout.close();               
		}
		// Catches any error conditions
		catch (IOException e){
			System.err.println ("Unable to write to file");
			System.exit(-1);
		}
	}
	
	
	/**
	 * This method clears the file
	 */
	public void clear(){
		
		FileOutputStream fout;          

		try{
			// Open an output stream
			fout = new FileOutputStream(file);

			// Print a line of text
			new PrintStream(fout).println("");

			// Close our output stream
			fout.close();               
		}
		// Catches any error conditions
		catch (IOException e){
			System.err.println ("Unable to write to file");
			System.exit(-1);
		}
	}
	
	/**
	 * This method returns the file-name
	 * @return The file name as a string.
	 */
	public String getFileName(){
		return file;
	}
}
