package CoPS.agents;
//
//  HandleAgreeBehaviour.java
//  CoPS
//
//  Created by Kari on 18.04.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

import jade.core.behaviours.OneShotBehaviour;
import jade.core.Agent;
import jade.lang.acl.MessageTemplate;
import jade.domain.FIPANames;
import jade.lang.acl.ACLMessage;

/**
 * This class implements the handleAgree - method in AdministerProblemSolvingProcessBehaviour
 * @author Kari Roessland
 */
public class HandleAgreeBehaviour extends OneShotBehaviour{
	/**
	 * The constructor.
	 * @param agent The owner of this behaviour.
	 */
	public HandleAgreeBehaviour(Agent agent){
		super(agent);
	}
	
	/**
	 * This method defines a messagetemplate and adds a new behaviour (ComposePSMBehaviour) to the agent that owns this behaviour.
	 */
	public void action(){
		
		//Initialise Message Template which is used for filtering which responses are being answered and which are not
		MessageTemplate template = MessageTemplate.and(
														   MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST),
														   MessageTemplate.MatchPerformative(ACLMessage.REQUEST)
														   );
		
		myAgent.addBehaviour(new ComposePSMBehaviour(myAgent, template));
		
	
	}
}
