//
//  CheckTeamSpaceRequestsBehaviour.java
//  Blackboard
//
//  Created by Kari on 15.05.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
package teamSpace.agent;

import jade.core.*;
import jade.core.behaviours.OneShotBehaviour;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.core.behaviours.DataStore;
import jade.domain.FIPANames;
import jade.core.behaviours.ParallelBehaviour;
import java.util.ArrayList;

/**
 * This class checks incoming request-messages, and add a parallel beahaviour
 * where the requests are handled in parallel.
 *
 * @author Kari Roessland
 */

public class CheckTeamSpaceRequestsBehaviour extends OneShotBehaviour{

	/**
	 * The constructor.
	 * @param agent The owner of this behaviour.
	 */
	public CheckTeamSpaceRequestsBehaviour(Agent agent){
		super(agent);
	}
	
	
	/**
	 * In this method the parallel behaviour is added.
	 */
	public void action(){
		//myAgent.doWait(5000);
		//Initialise Message Template which is going to be used
		MessageTemplate template = MessageTemplate.and(
													   MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_REQUEST),
													   MessageTemplate.MatchPerformative(ACLMessage.REQUEST)
													   );
		
		
		ArrayList requests = new ArrayList();
		ACLMessage request = null;
		boolean hasMoreMsg = true;
		boolean first = true;
		
		while(hasMoreMsg){
			
			if(first){
				request = myAgent.blockingReceive(template);
				first = false;
			}else{
				request = myAgent.blockingReceive(2000);
			}
			
			if(request == null){
				hasMoreMsg = false;
			}else{
				requests.add(request);
			}
		}

		ParallelBehaviour pb = new ParallelBehaviour(myAgent, ParallelBehaviour.WHEN_ALL);
		
		TeamSpaceAgentBehaviour tsab = null;
		
		
		for(int i = 0; i < requests.size(); i++){
		
			tsab = new TeamSpaceAgentBehaviour(myAgent, template, new DataStore());
			pb.addSubBehaviour(tsab);
		
		}
		
		myAgent.addBehaviour(pb);
		
		
		for(int i = 0; i < requests.size(); i++){
			request = (ACLMessage)requests.get(i);
			
		
			myAgent.putBack(request);
		}
		
	}
	

}

