//
//  DFRegisteringBehaviour.java
//  Rules
//
//  Created by Kari on 27.02.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
package teamSpace.agent; 

//JADE classes
import jade.core.behaviours.OneShotBehaviour;
import jade.core.Agent; 
import jade.lang.acl.ACLMessage;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.DFService;

/**
 * This class contains the behaviour for registering a service with the DF, extends OneShotBehaviour
 *
 * @author Kari Roessland
 */            
public class DFRegisteringBehaviour extends OneShotBehaviour{
	ServiceDescription sd = null;
	
	/**
	 * The constructor calls the super-constructor and sets the <code>ServiceDescription</code>
	 * of this class.
	 * @param ag The owner agent of this behaviour
	 * @param sd The service description of the owner-agent
	 */
	public DFRegisteringBehaviour(Agent ag, ServiceDescription sd){
        super(ag);
		this.sd = sd;
    }
    
	/**
	 * The method registeres the services of the agent that owns this method.
	 */
    public void action(){
        DFAgentDescription dfd = new DFAgentDescription();
        dfd.setName(myAgent.getAID());
        dfd.addServices(this.sd);
        try{
            DFAgentDescription[] dfds = DFService.search(myAgent, dfd);
            if(dfds.length>0){ DFService.deregister(myAgent, dfd); }
            DFService.register(myAgent, dfd);
            System.out.println("    "+myAgent.getLocalName() +" is ready!");
        }catch(Exception e){
            System.out.println("    "+myAgent.getLocalName() +" not Able to register with DF. Agent shutting down!");
            e.printStackTrace();
            myAgent.doDelete();
        }
    }
}