package teamSpace.structure;
//
//  TSAction.java
//  Blackboard
//
//  Created by Kari on 17.04.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

/**
 * The TSPSM class represents an action which is defined in the TMST (task structure tree)
 * kept by the {@link PlanLibrary} class. The class will only serve as a keeper of information about an action.
 * @author Kari Roessland
 */
public class TSAction extends TSTMSTNode{
	String actionType;
	
	/**
	 * The constructor initializes the name, input executor and partial results
	 * of the action, by calling the super-class and by setting the <code>actionType</code> 
	 * variable.
	 * @param name - The name of the action
	 * @param input - The input of the action
	 * @param executor - The executor of the action
	 * @param actionType - The action type
	 */
	public TSAction(String name, String input, String executor, String actionType){
		super(name, input, executor);
		this.actionType = actionType;
	}
	
	
	/**
	 * The method returns the action type
	 * @return The action type
	 */
	public String getActionType(){
		return actionType;
	}
	

}
