package teamSpace.structure;
//
//  TSGoal.java
//  Blackboard
//
//  Created by Kari on 18.04.06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//


/**
 * The TSGoal class represents a goal whichs is defined in the TMST (task structure tree)
 * kept by the {@link PlanLibrary} class.
 * @author Kari Roessland
 */
public class TSGoal {
	String name;
	String output;
	
	/**
	 * The constructor instantiate the name and the output of the goal.
	 * @param name The goal name
	 * @param output The goal output
	 */
	public TSGoal(String name, String output){
		this.name = name;
		this.output = output;
	}
	
	/**
	 * The method returns the name of the goal
	 * @return The name of the goal as a {@link String}
	 */
	public String getName(){
		return name;
	}
	
	/**
	 * The method returns the output of the goal
	 * @return The output of the goal as a {@link String}
	 */
	public String getOutput(){
		return output;
	}
}
