package TMST.representation;

//
//  ActionType.java
//  TMST
//
//  Created by Odd Erik  Gundersen on Wed Apr 14 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

//Java
import java.util.Collection;

//jCreek
import jcreek.representation.Entity;
import jcreek.representation.EntityType;
//import jcreek.representation.cbr.IsoPodModel;
import jcreek.representation.BasicModel;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.representation.EntityTypeNotMatchedException;

/**
	Class represnting the type of an action
*/
public class ActionType extends EntityType{

	/**
		The contructor setting up the entity in the model by relating the given action type to a generic
		Action Type entity for making it explisit that the given action type entity is a action type. 
		@param tmst The knowledge model this action type belongs to
		@param name The name of the action typee
		@param description The description of the action type
	 */
	public ActionType(TMST tmst, String name, String description) throws NameAlreadyExistException{
		super((KnowledgeModel)tmst, name, description);		
		try{
			//The model need a Value-object 
			if(!tmst.hasEntity("ACTION_TYPE")){
				Entity value = new Entity((KnowledgeModel)tmst, "ACTION_TYPE", "ACTION_TYPE");
				value.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity(BasicModel.SYMBOL));
			}		
			this.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity("ACTION_TYPE"));
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ActionType(Entity ent)throws EntityTypeNotMatchedException{
		super(ent);
	}
	
	/**
		Method which has to be overriden (from the class EntityType)
	 */
	public static boolean matches(Entity value){
		TMST tmst = (TMST)value.getKnowledgeModel();
		Entity ent = tmst.getEntity("ACTION_TYPE");
		
		if (ent == null) return false; 
		
		Collection subclasses = ent.getAllSubclassesCollection();
		
		if(value.getName().equals("ACTION_TYPE")){
			return false;
		}else if(subclasses.contains(value)){
			return true;
		}
		return false;
	}	
}