package TMST.representation;
//
//  Goal.java
//  TMST
//
//  Created by Odd Erik  Gundersen on Mon Feb 16 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

//Java
import java.util.Collection;

//jCreek
import jcreek.representation.Entity;
import jcreek.representation.Relation;
import jcreek.representation.RelationType;
import jcreek.representation.EntityType;
//import jcreek.representation.cbr.IsoPodModel;
import jcreek.representation.BasicModel;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.representation.EntityTypeNotMatchedException;

//TMST
import TMST.Exceptions.AlreadyHasValueException;


public class Goal extends EntityType{

	public Goal(TMST tmst, String name, String description, String value) throws NameAlreadyExistException{
		super((KnowledgeModel)tmst, name, description);
		System.out.println("Inni konstruktor til GOAL");
		try{
			//The model need a Goal-object 
			if(!tmst.hasEntity("GOAL")){
				Entity goal= new Entity((KnowledgeModel)tmst, "GOAL", "GOAL");
				goal.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity(BasicModel.SYMBOL));
			}
			this.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity("GOAL"));
		
			//Relate the value to this output			
			RelationType hasValue = tmst.getRelationType("HAS_VALUE");
			
			if(hasValue==null){
				//Has to make new Relation type
				hasValue = new RelationType((KnowledgeModel)tmst, tmst.getRelationType(BasicModel.HAS_VALUE_TYPE), "HAS_VALUE", "Relation pointing to a value", 1.0);
			}
			
			try{
				new Value(tmst, value, value);
			}catch(NameAlreadyExistException e){
				System.out.println("GOAL: " +e.getMessage());
			}
			
			new Relation(this, hasValue, tmst.getEntity(value));			
			
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public Goal(Entity ent) throws EntityTypeNotMatchedException{
		super(ent);
	}
	
	
/*	public Goal(TMST tmst, String name, String description, Value value) throws NameAlreadyExistException{
		super((KnowledgeModel)tmst, name, description);
		try{
			//The model need a Goal-object 
			if(!tmst.hasEntity("GOAL")){
				Entity goal= new Entity((KnowledgeModel)tmst, "GOAL", "GOAL");
				goal.addRelation(IsoPodModel.INSTANCE_OF, tmst.getEntity(IsoPodModel.SYMBOL));
			}
			this.addRelation(IsoPodModel.INSTANCE_OF, tmst.getEntity("GOAL"));

			//Relate the value to this output
			RelationType hasValue = tmst.getRelationType("HAS_VALUE");
			
			if(hasValue==null){
				//Has to make new Relation type
				hasValue = new RelationType((KnowledgeModel)tmst, tmst.getRelationType(IsoPodModel.STRUCTURAL_RELATION), "HAS_VALUE", "Relation pointing to a value", 1.0);
			}
			new Relation(this, hasValue, value);			
		}catch(Exception e){
			e.printStackTrace();
		}
	}*/
	
	/**
		Method returning the value of the goal
		@return The value assigned to the goal
	*/
	public Value getValue()throws AlreadyHasValueException{
		Value value = null;
		
		Relation rels[] = this.getLocalRelations("HAS_VALUE");
		if(rels==null){
			return value;
		}
		if(rels.length>1){
			throw new AlreadyHasValueException("An output may only have one value. Something is terrible wrong");
		}
		value = (Value)rels[0].getValue();
		return value;		
	}
	
	/*
		Method which has to be overriden (from the class EntityType)
	*/
	public static boolean matches(Entity value){
		TMST tmst = (TMST)value.getKnowledgeModel();
		Entity ent = tmst.getEntity("GOAL");
		
		if (ent == null) return false; 
		
		Collection subclasses = ent.getAllSubclassesCollection();

		if(value.getName().equals("GOAL")){
			return false;
		}else if(subclasses.contains(value)){
			return true;
		}
		return false;
	}
}
