package TMST.representation;

//
//  Value.java
//  TMST
//
//  Created by Odd Erik  Gundersen on Mon Feb 16 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

//Java
import java.util.Collection;

//jCreek
import jcreek.representation.Entity;
import jcreek.representation.EntityType;
//import jcreek.representation.cbr.IsoPodModel;
import jcreek.representation.BasicModel;
import jcreek.representation.KnowledgeModel;
import jcreek.representation.NameAlreadyExistException;
import jcreek.representation.EntityTypeNotMatchedException;

/**
	Class representing the values of goals, inputs and outputs.
*/
public class Value extends EntityType{

	/**
		Constructor setting up the value entity, also relating it to a generic value entity.
		@param tmst The knowledge model this value belongs to
		@param name The value of the goal, input or output
		@param description The description of the value
	*/
	public Value(TMST tmst, String name, String description) throws NameAlreadyExistException{
		super((KnowledgeModel)tmst, name, description);
		
		try{
			//The model need a Value-object 
			if(!tmst.hasEntity("VALUE")){
				Entity value = new Entity((KnowledgeModel)tmst, "VALUE", "VALUE");
				value.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity(BasicModel.SYMBOL));
			}		
			this.addRelation(BasicModel.INSTANCE_OF, tmst.getEntity("VALUE"));
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public Value(Entity ent) throws EntityTypeNotMatchedException{
		super(ent);
	}
	
	/**
		Method which has to be overriden (from the class EntityType)
	*/
	public static boolean matches(Entity value){
		TMST tmst = (TMST)value.getKnowledgeModel();
		Entity ent = tmst.getEntity("VALUE");
		
		if (ent == null) return false; 
		
		Collection subclasses = ent.getAllSubclassesCollection();

		if(value.getName().equals("VALUE")){
			return false;				
		}else if(subclasses.contains(value)){
			return true;
		}
		return false;
	}
}

